HDU 1025 Constructing Roads In JGShining's Kingdom[动态规划/nlogn求最长非递减子序列]
Constructing Roads In JGShining's Kingdom
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 27358 Accepted Submission(s): 7782
Half
of these cities are rich in resource (we call them rich cities) while
the others are short of resource (we call them poor cities). Each poor
city is short of exactly one kind of resource and also each rich city is
rich in exactly one kind of resource. You may assume no two poor cities
are short of one same kind of resource and no two rich cities are rich
in one same kind of resource.
With the development of industry,
poor cities wanna import resource from rich ones. The roads existed are
so small that they're unable to ensure the heavy trucks, so new roads
should be built. The poor cities strongly BS each other, so are the rich
ones. Poor cities don't wanna build a road with other poor ones, and
rich ones also can't abide sharing an end of road with other rich ones.
Because of economic benefit, any rich city will be willing to export
resource to any poor one.
Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.
The
location of Rich City 1 is on the left of all other cities, Rich City 2
is on the left of all other cities excluding Rich City 1, Rich City 3
is on the right of Rich City 1 and Rich City 2 but on the left of all
other cities ... And so as the poor ones.
But as you know, two
crossed roads may cause a lot of traffic accident so JGShining has
established a law to forbid constructing crossed roads.
For example, the roads in Figure I are forbidden.
In
order to build as many roads as possible, the young and handsome king
of the kingdom - JGShining needs your help, please help him. ^_^
test case will begin with a line containing an integer n(1 ≤ n ≤
500,000). Then n lines follow. Each line contains two integers p and r
which represents that Poor City p needs to import resources from Rich
City r. Process to the end of file.
You should tell JGShining what's the maximal number of road(s) can be built.
1 2
2 1
3
1 2
2 3
3 1
My king, at most 1 road can be built.
Case 2:
My king, at most 2 roads can be built.
Huge input, scanf is recommended.
[分析]:假设存在一个序列d[1..9] = 2 1 5 3 6 4 8 9 7,可以看出来它的LIS长度为5。
下面一步一步试着找出它。
我们定义一个序列B,然后令 i = 1 to 9 逐个考察这个序列。
此外,我们用一个变量Len来记录现在最长算到多少了
首先,把d[1]有序地放到B里,令B[1] = 2,就是说当只有1一个数字2的时候,长度为1的LIS的最小末尾是2。这时Len=1
然后,把d[2]有序地放到B里,令B[1] = 1,就是说长度为1的LIS的最小末尾是1,d[1]=2已经没用了,这时Len=1
接着,d[3] = 5,d[3]>B[1],所以令B[1+1]=B[2]=d[3]=5,就是说长度为2的LIS的最小末尾是5,这时候B[1..2] = 1, 5,Len=2
再来,d[4] = 3,它正好加在1,5之间,放在1的位置显然不合适,因为1小于3,长度为1的LIS最小末尾应该是1,长度为2的LIS最小末尾是3,于是可以把5淘汰掉,这时候B[1..2] = 1, 3,Len = 2
继续,d[5] = 6,它在3后面,因为B[2] = 3, 而6在3后面,于是很容易可以推知B[3] = 6, 这时B[1..3] = 1, 3, 6,还是很容易理解吧? Len = 3.
第6个, d[6] = 4,你看它在3和6之间,于是我们就可以把6替换掉,得到B[3] = 4。B[1..3] = 1, 3, 4,Len继续等于3
第7个, d[7] = 8,它很大,比4大,于是B[4] = 8。Len变成4了
第8个, d[8] = 9,得到B[5] = 9,Len继续增大,到5了。
最后一个, d[9] = 7,它在B[3] = 4和B[4] = 8之间,So最新的B[4] =7,B[1..5] = 1, 3, 4, 7, 9,Len = 5。
于是我们知道了LIS的长度为5。
注意。这个1,3,4,7,9不是LIS,它只是存储的对应长度LIS的最小末尾。有了这个末尾,我们就可以一个一个地插入数据。虽然最后一个d[9] = 7更新进去对于这组数据没有什么意义,但是如果后面再出现两个数字8和9.那么就可以把8更新到d[5],
9更新到d[6],得出LIS的长度为6。
然后应该发现一件事情了:在B中插入数据是有序的,而且是进行替换而不需要挪动—也就是说,我们可以使用二分查找,将每一个数字的插入时间优化到O(logN)
/*
输入一个m,n分别表示成m组,一共有n个数
即将n个数分成m组,
m组的和加起来得到最大值并输出。
*/
#include <bits/stdc++.h>
using namespace std;
const int N=;
#define INF 0x7fffffff int n;
int a[N],dp[N]; int main()
{
int t=;
while(cin>>n)
{
int x,y;
for(int i=;i<=n;i++)
{
scanf("%d%d",&x,&y);
a[x]=y;
}
for(int i=;i<=n;i++) dp[i]=INF;
int ans=;
for(int i=;i<=n;i++)
{
int tmp=lower_bound(dp+,dp+n+,a[i])-dp;
dp[tmp]=a[i];
ans=max(ans,tmp);
}
printf("Case %d:\nMy king, at most %d road%s can be built.\n\n",++t,ans,ans==?"":"s");
}
}
/*
假设要寻找最长上升子序列的序列是a[n],然后寻找到的递增子序列放入到数组dp中。 (1)当遍历到数组a的第一个元素的时候,就将这个元素放入到dp数组中,以后遍历到的元素都和已经放入到dp数组中的元素进行比较; (2)如果比dp数组中的每个元素都大,则将该元素插入到dp数组的最后一个元素,并且dp数组的长度要加1; (3)如果比dp数组中最后一个元素小,就要运用二分法进行查找,查找出第一个比该元素大的最小的元素,然后将其替换。 在这个过程中,只重复执行这两步就可以了,最后b数组的长度就是最长的上升子序列长度。例如:如该数列为: 5 9 4 1 3 7 6 7 那么: 5 //加入
5 9 //加入
4 9 //用4代替了5
1 9 //用1代替4
1 3 //用3代替9
1 3 7 //加入
1 3 6 //用6代替7
1 3 6 7 //加入 最后b中元素的个数就是最长递增子序列的大小,即4。 要注意的是最后数组里的元素并不就一定是所求的序列, 例如如果输入 2 5 1 那么最后得到的数组应该是 1 5 而实际上要求的序列是 2 5
*/ #include <bits/stdc++.h>
using namespace std;
const int N=;
#define INF 0x7fffffff int n;
int a[N],dp[N];
int Find(int num,int l,int r)//用二分查找的方法找到一个位置,使得num>dp[i-1] 并且num<dp[i],并用num代替dp[i]
{
int mid;
while(l<=r)
{
mid=(l+r)>>;
if(num>=dp[mid])
l=mid+;
else
r=mid-;
}
return l;
}
int DP(int n)
{
int len,pos;
dp[]=a[];
len=;
for(int i=;i<=n;i++)
{
if(a[i]>dp[len])//如果a[i]比dp[]数组中最大还大直接插入到后面即可
{
len++;
dp[len]=a[i];
}
else//用二分的方法在b[]数组中找出第一个比a[i]大的位置并且让a[i]替代这个位置
{
pos=Find(a[i],,len);
dp[pos]=a[i];
}
}
return len;
}
int main()
{
int t=;
while(cin>>n)
{
int x,y;
for(int i=;i<=n;i++)
{
scanf("%d%d",&x,&y);
a[x]=y;
}
int ans=DP(n);
printf("Case %d:\nMy king, at most %d road%s can be built.\n\n",++t,ans,ans==?"":"s");
}
}
注释详解
HDU 1025 Constructing Roads In JGShining's Kingdom[动态规划/nlogn求最长非递减子序列]的更多相关文章
- HDOJ(HDU).1025 Constructing Roads In JGShining's Kingdom (DP)
HDOJ(HDU).1025 Constructing Roads In JGShining's Kingdom (DP) 点我挑战题目 题目分析 题目大意就是给出两两配对的poor city和ric ...
- HDU 1025 Constructing Roads In JGShining's Kingdom(二维LIS)
Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65 ...
- [ACM] hdu 1025 Constructing Roads In JGShining's Kingdom (最长递增子序列,lower_bound使用)
Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65 ...
- hdu 1025:Constructing Roads In JGShining's Kingdom(DP + 二分优化)
Constructing Roads In JGShining's Kingdom Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65 ...
- hdu 1025 Constructing Roads In JGShining’s Kingdom 【dp+二分法】
主题链接:pid=1025">http://acm.acmcoder.com/showproblem.php?pid=1025 题意:本求最长公共子序列.但数据太多. 转化为求最长不下 ...
- HDU 1025 Constructing Roads In JGShining's Kingdom(求最长上升子序列nlogn算法)
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1025 解题报告:先把输入按照r从小到大的顺序排个序,然后就转化成了求p的最长上升子序列问题了,当然按p ...
- HDU 1025 Constructing Roads In JGShining's Kingdom(DP+二分)
点我看题目 题意 :两条平行线上分别有两种城市的生存,一条线上是贫穷城市,他们每一座城市都刚好只缺乏一种物资,而另一条线上是富有城市,他们每一座城市刚好只富有一种物资,所以要从富有城市出口到贫穷城市, ...
- hdu 1025 Constructing Roads In JGShining's Kingdom
本题明白题意以后,就可以看出是让求最长上升子序列,但是不知道最长上升子序列的算法,用了很多YY的方法去做,最后还是超时, 因为普通算法时间复杂度为O(n*2),去搜了题解,学习了一下,感觉不错,拿出来 ...
- 最长上升子序列 HDU 1025 Constructing Roads In JGShining's Kingdom
最长上升子序列o(nlongn)写法 dp[]=a[]; ; ;i<=n;i++){ if(a[i]>dp[len]) dp[++len]=a[i]; ,dp++len,a[i])=a[i ...
随机推荐
- RCP 项目启动图片设置
第一步 选择启动图片命名为 splash.bmp 第二步 添加 扩展点 然 后在右边的扩展元素细节中填入相应的信息,比如我们在这里的application属 性 为 org.vwpolo.rcp.ex ...
- 基类View
尽管类视图看上去类的种类繁多,但每个类都是各司其职的,且从类的命名就可以很容易地看出这个类的功能.大致可分为如下三个大的功能块,分别由三个类提供对应的方法: 处理 HTTP 请求.根据 HTTP 请求 ...
- 实时视频h5
http://www.cnblogs.com/dotfun/p/4286878.html
- Bit Operation妙解算法题
5道巧妙位操作的算法题. ***第一道*** 题目描述 给定一个非空整数数组,除了某个元素只出现一次以外,其余每个元素均出现两次.找出那个只出现了一次的元素. 说明: 你的算法应该具有线性时间复杂度. ...
- 【Appnium+C#+Winform自动化测试系列】一、获取本机连接的设备、启动多个Appnium和获取本机启动的Appnium
本系列内容,准备根据所完成的项目为基线,一步一步的把整个设计和实现过程梳理. 先从基本的一些环境问题入手,梳理清楚关于手机设备和Appnium.因为我们在后面的建立Appnium连接时,需要设备名字和 ...
- [oldboy-django][2深入django]mysql查询语句--原生sql
# 增(一共有三种方式) # 插入单条记录 insert into t1(name,...) values('lzp',..); 注意一点:t1(name,...)必须包含所有非空列(除去自增列) # ...
- HDU5862 Counting Intersections
Given some segments which are paralleled to the coordinate axis. You need to count the number of the ...
- 使用 宝塔面板快速部署Java项目
环境描述: 服务器系统:CentOS7 64位操作系统 面板版本:宝塔6.9.4 Nginx版本:Nginx 1.16 Tomcat版本:Tomcat7 JDK版本:1.8.0_121 环境部署就不用 ...
- 【bzoj1095】[ZJOI2007]Hide 捉迷藏 动态点分治+堆
题目描述 捉迷藏 Jiajia和Wind是一对恩爱的夫妻,并且他们有很多孩子.某天,Jiajia.Wind和孩子们决定在家里玩捉迷藏游戏.他们的家很大且构造很奇特,由N个屋子和N-1条双向走廊组成,这 ...
- MpLab设置编译文件输出路径
MpLab设置编译文件输出路径